using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using Ceras;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapName = "Broken Bridge(map)";
		public static Sprite TilePreviewLoaded513948928 = ModAPI.LoadSprite("TilePreviewLoaded513948928.png");
        public static Sprite TilePreviewLoaded486035712 = ModAPI.LoadSprite("TilePreviewLoaded486035712.png");
        public static Sprite TilePreviewLoaded235070240 = ModAPI.LoadSprite("TilePreviewLoaded235070240.png");
        public static Sprite CircleLoaded453999520 = ModAPI.LoadSprite("CircleLoaded453999520.png");
        public static Sprite CircleLoaded898671872 = ModAPI.LoadSprite("CircleLoaded898671872.png");
        public static Sprite TilePreviewLoaded826692544 = ModAPI.LoadSprite("TilePreviewLoaded826692544.png");
        public static Sprite TilePreviewLoaded408694784 = ModAPI.LoadSprite("TilePreviewLoaded408694784.png");
        public static Sprite TilePreviewLoaded946389504 = ModAPI.LoadSprite("TilePreviewLoaded946389504.png");
        public static Sprite TilePreviewLoaded318699808 = ModAPI.LoadSprite("TilePreviewLoaded318699808.png");
        public static Sprite TilePreviewLoaded553624512 = ModAPI.LoadSprite("TilePreviewLoaded553624512.png");
        public static Sprite TilePreviewLoaded378527008 = ModAPI.LoadSprite("TilePreviewLoaded378527008.png");
        public static Sprite TilePreviewLoaded391556512 = ModAPI.LoadSprite("TilePreviewLoaded391556512.png");
        public static Sprite TilePreviewLoaded774635008 = ModAPI.LoadSprite("TilePreviewLoaded774635008.png");
        public static Sprite TilePreviewLoaded883706944 = ModAPI.LoadSprite("TilePreviewLoaded883706944.png");
        public static Sprite TilePreviewLoaded301308640 = ModAPI.LoadSprite("TilePreviewLoaded301308640.png");
        public static Sprite TilePreviewLoaded244207792 = ModAPI.LoadSprite("TilePreviewLoaded244207792.png");
        public static Sprite TilePreviewLoaded175684256 = ModAPI.LoadSprite("TilePreviewLoaded175684256.png");
        public static Sprite TilePreviewLoaded692554304 = ModAPI.LoadSprite("TilePreviewLoaded692554304.png");
        public static Sprite TilePreviewLoaded173006720 = ModAPI.LoadSprite("TilePreviewLoaded173006720.png");
        public static Sprite TilePreviewLoaded666779392 = ModAPI.LoadSprite("TilePreviewLoaded666779392.png");
        public static Sprite TilePreviewLoaded658064320 = ModAPI.LoadSprite("TilePreviewLoaded658064320.png");
        public static Sprite TilePreviewLoaded326574112 = ModAPI.LoadSprite("TilePreviewLoaded326574112.png");
        public static Sprite TilePreviewLoaded211799536 = ModAPI.LoadSprite("TilePreviewLoaded211799536.png");
        public static Sprite TilePreviewLoaded110415456 = ModAPI.LoadSprite("TilePreviewLoaded110415456.png");
        public static Sprite TilePreviewLoaded443195136 = ModAPI.LoadSprite("TilePreviewLoaded443195136.png");
        public static Sprite TilePreviewLoaded290618400 = ModAPI.LoadSprite("TilePreviewLoaded290618400.png");
        public static Sprite TilePreviewLoaded214045376 = ModAPI.LoadSprite("TilePreviewLoaded214045376.png");
        public static Sprite TilePreviewLoaded138180320 = ModAPI.LoadSprite("TilePreviewLoaded138180320.png");
        public static Sprite TilePreviewLoaded115235664 = ModAPI.LoadSprite("TilePreviewLoaded115235664.png");
        public static Sprite TilePreviewLoaded355104768 = ModAPI.LoadSprite("TilePreviewLoaded355104768.png");
        public static Sprite TilePreviewLoaded878486400 = ModAPI.LoadSprite("TilePreviewLoaded878486400.png");
        public static Sprite TilePreviewLoaded130779400 = ModAPI.LoadSprite("TilePreviewLoaded130779400.png");
        public static Sprite TilePreviewLoaded634099968 = ModAPI.LoadSprite("TilePreviewLoaded634099968.png");
        public static Sprite TilePreviewLoaded987983 = ModAPI.LoadSprite("TilePreviewLoaded987983.png");
        public static Sprite TilePreviewLoaded204733936 = ModAPI.LoadSprite("TilePreviewLoaded204733936.png");
        public static Sprite CustomSprite1Loaded722400000 = ModAPI.LoadSprite("CustomSprite1Loaded722400000.png");
        

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void CreateMap(MapSelectionMenuBehaviour mapmenuthingy, string name, string desc, Sprite thumb)
		{
			if (!Done)
			{
				Vol = ScriptableObject.CreateInstance<Map>();
				Vol.name = name;
				mapname = Vol.name;
				Vol.Description = desc;
				Vol.Thumbnail = thumb;
				var baseplate = Resources.Load<Map>("Maps/Default");
				Vol.Prefab = baseplate.Prefab;
			}
			Done = true;
			var mapviewbutton = UnityEngine.Object.Instantiate<GameObject>(mapmenuthingy.MapViewPrefab, Vector3.zero, Quaternion.identity, mapmenuthingy.transform);
			mapviewbutton.GetComponent<MapViewBehaviour>().Map = Vol;
			UISoundBehaviour.Refresh();
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
		}

		public static void OnLoad()
		{
			CreateMap(mapmenu, MapName, "Template", TemplateSprite);
			SceneManager.sceneLoaded += OnSceneLoaded;
		}

		public static void OnSceneLoaded(Scene scene, LoadSceneMode mode)
		{
			if (debounce == false)
			{
				debounce = true;
				var obj = new GameObject();
				obj.AddComponent<MapLoadingStuff>();
			}
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
                {
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity); 
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders(); 
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
			var whitespace = Texture2D.whiteTexture;
			whitespace.Resize(16, 16);
			whitespace.Apply();
			if (IsTexture == true)
			{
				var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
														(int)spritey.textureRect.y,
														(int)spritey.textureRect.width,
														(int)spritey.textureRect.height);
				croppedTexture.SetPixels(pixels);
				croppedTexture.wrapMode = TextureWrapMode.Repeat;
				croppedTexture.filterMode = FilterMode.Point;
				croppedTexture.Apply();
				var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
				NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
				NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			else
			{
				NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				NewGameobject.GetComponent<SpriteRenderer>().color = color;
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			Map eggs = Resources.Load<Map>("Maps/Sea");
			GameObject WaterBefore = eggs.Prefab.transform.Find("Root/Sea").gameObject;
			var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
			Water.transform.rotation = Rotation;
			Water.transform.localScale = new Vector2(Size.x, -Size.y);
			///Water.transform.SetParent(GameObject.Find("Root").transform);
			Water.transform.localPosition = Pos;
			Water.AddComponent<WaterBlockBehaviour>().GlobalTop = Water.GetComponent<SpriteRenderer>().bounds.max.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalBottom = Water.GetComponent<SpriteRenderer>().bounds.min.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalLeft = Water.GetComponent<SpriteRenderer>().bounds.min.x;
			Water.GetComponent<WaterBlockBehaviour>().GlobalRight = Water.GetComponent<SpriteRenderer>().bounds.max.x;
			Water.GetComponent<WaterBlockBehaviour>().WaterSize = Size;
			Water.GetComponent<WaterBlockBehaviour>().WaterCenter = Pos;
			Water.GetComponent<WaterBlockBehaviour>().Drag = Water.GetComponent<WaterBehaviour>().Drag;
			Water.GetComponent<WaterBlockBehaviour>().Buoyancy = Water.GetComponent<WaterBehaviour>().Buoyancy;
			Water.GetComponent<WaterBlockBehaviour>().Trigger = Water.GetComponent<WaterBehaviour>().Trigger;
			Water.GetComponent<WaterBlockBehaviour>().Splash = UnityEngine.Object.Instantiate<GameObject>(Water.GetComponent<WaterBehaviour>().Splash);
			Water.GetComponent<WaterBlockBehaviour>().Splash.SetActive(false);
			Water.GetComponent<WaterBlockBehaviour>().Layers = Water.GetComponent<WaterBehaviour>().Layers;
			Water.GetComponent<WaterBlockBehaviour>().ObjectsToBeActiveIfWater = Water.GetComponent<WaterBehaviour>().ObjectsToBeActiveIfWater;
			Water.GetComponent<WaterBlockBehaviour>().BoilingWaterSound = Water.GetComponent<WaterBehaviour>().BoilingWaterSound;
			Water.GetComponent<WaterBlockBehaviour>().Ice = Water.GetComponent<WaterBehaviour>().Ice;
			Water.GetComponent<WaterBehaviour>().enabled = false;
			WaterBlockBehaviour.Instance = Water.GetComponent<WaterBlockBehaviour>();
			var main = Water.GetComponentInChildren<ParticleSystem>().main;
			var shape = Water.GetComponentInChildren<ParticleSystem>().shape;
			var emission = Water.GetComponentInChildren<ParticleSystem>().emission;
			main.scalingMode = ParticleSystemScalingMode.Shape;
			shape.scale = Size;
			shape.rotation = Water.transform.eulerAngles;
			emission.rateOverTimeMultiplier = 1f * (Size.x / 4.8f);
			if (Type == "Lava")
			{
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Lava;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				Water.GetComponent<WaterBlockBehaviour>().Lava = true;
				var light = ModAPI.CreateLight(Water.transform, new Color32(255, 129, 32, 255), 15, 5);
				Water.AddComponent<LavaBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
                {
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Lava.texture;
					main2.startColor = new Color(1f, 0.5f, 0.12f, 1f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy = 0f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.6f;
			}
			else if (Type == "Acid")
			{
				Water.GetComponent<SpriteRenderer>().color = new Color(0, 1, 0, 1);
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Acid;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				var AcidLight = ModAPI.CreateLight(Water.transform, new Color(0, 1, 0, 1), 4, 3);
				Water.GetComponent<WaterBlockBehaviour>().Lava = true;
				Water.AddComponent<AcidBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
				{
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Acid.texture;
					main2.startColor = new Color(0, 1, 0, 0.8f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy -= 0.1f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.4f;
			}
			GameObject.Destroy(Water.GetComponent<WaterBehaviour>());
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap == Vol)
            {
				Debug.Log("Setting up some stuff.");
				
				CreateGameObjects("Other", new Vector2(109.3883f, 2.157996f), new Vector2(-484f, 388f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(288.5685f, 1.024851f), new Vector2(-484f, 388f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(288.6171f, 42.35679f), new Vector2(276.5f, 2558.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.2411f, 41.60876f), new Vector2(276.5f, 2558.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateWaterBlock(new Vector3(-701.8f, 50.2f, 1f), new Vector3(344.8734f, 21.86895f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateGameObjects("Other", new Vector2(87.68969f, 77.75405f), new Vector2(2596.5f, 104.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(284.5511f, 77.95863f), new Vector2(3671f, 104.5f), Quaternion.Euler(0f, 0f, 359.7f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(396.5981f, 77.70495f), new Vector2(3671f, 104.5f), Quaternion.Euler(0f, 0f, 182.6f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(162.0157f, 76.3428f), new Vector2(-2596.5f, 104.5f), Quaternion.Euler(0f, 0f, 357.8f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(124.9254f, 78.70898f), new Vector2(41.57007f, 13.22125f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(122.8296f, 78.53138f), new Vector2(41.57007f, 13.22125f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(124.7122f, 77.64336f), new Vector2(37.8407f, 13.22125f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(124.9609f, 76.79089f), new Vector2(41.57007f, 13.22125f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.2698f, 110.248f), new Vector2(-227.3552f, 1624.108f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(106.1483f, 83.09839f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 0f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(112.3836f, 83.26579f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 0f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(116.4319f, 132.17f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 73.50002f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(123.9272f, 128.9396f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 61.2f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(131.1443f, 124.8545f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 60f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(138.3128f, 120.749f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 60f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(145.4423f, 116.548f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 59.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(152.5913f, 112.2586f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 60f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(159.8084f, 108.0372f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 60f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(167.0255f, 103.884f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 60f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(174.2426f, 99.73077f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 60f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(180.6f, 94.8f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 45f), "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(186.43f, 88.90512f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 45f), TilePreviewLoaded513948928, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(192.2854f, 82.98164f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 45f), TilePreviewLoaded486035712, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(196.711f, 77.26243f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 30.2f), TilePreviewLoaded235070240, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(114.1546f, 128.344f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 30.40001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(118.2408f, 121.2717f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(122.2484f, 114.0423f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(126.2561f, 106.8129f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(130.2637f, 99.66206f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(134.2713f, 92.5898f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(138.2003f, 85.51756f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(141.1864f, 80.17407f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 29.10001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(115.3651f, 129.7094f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(120.7476f, 124.0962f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(126.3609f, 118.4829f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(132.8199f, 113.408f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 59.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(139.8941f, 109.1788f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 59.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(146.8914f, 104.9497f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 59.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(153.2736f, 99.87471f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(159.0406f, 93.95391f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(164.8076f, 88.11001f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(170.4f, 82.2f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(174.1886f, 78.03696f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 44.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(113.3425f, 120.2425f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 14f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(114.1295f, 112.3534f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 359.1f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(108.9976f, 134.472f), new Vector2(14.00008f, 262.1069f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.1332f, 137.8051f), new Vector2(-121.0987f, 11.20007f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.0335f, 137.007f), new Vector2(-88.39916f, 6.700062f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(228.8646f, 70.97219f), new Vector2(394.0149f, 98.19914f), Quaternion.Euler(0f, 0f, 74.8f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(214.8396f, 0.4840527f), new Vector2(553.7119f, 87.19931f), Quaternion.Euler(0f, 0f, 345f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(231.0021f, 77.71345f), new Vector2(142.8f, 8.399999f), Quaternion.Euler(0f, 0f, 47.20003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(231.8052f, 76.85361f), new Vector2(8.399999f, 75.60001f), Quaternion.Euler(0f, 0f, 325f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(343.5571f, 75.95346f), new Vector2(61.25718f, 13.82126f), Quaternion.Euler(0f, 0f, 15f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(344.5587f, 75.20191f), new Vector2(60.19972f, 17.1001f), Quaternion.Euler(0f, 0f, 15.4f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(337.4751f, 78.37282f), new Vector2(42f, 12.70008f), Quaternion.Euler(0f, 0f, 346f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(337.1812f, 77.43241f), new Vector2(66.49963f, 11.00007f), Quaternion.Euler(0f, 0f, 313.8f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(800.3931f, 116.753f), new Vector2(-24628f, 68322f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(437.0363f, 57.0593f), new Vector2(-26.40006f, 19.30004f), Quaternion.Euler(0f, 0f, 0f), CircleLoaded453999520, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(410.5426f, 22.74082f), new Vector2(39.79996f, -29.60008f), Quaternion.Euler(0f, 0f, 0f), CircleLoaded898671872, "Front", false, 0);
                CreateGameObjects("Other", new Vector2(368.1951f, 7.635162f), new Vector2(381.3141f, 924.9213f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(448.3713f, 0.9215393f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(449.146f, -0.2404366f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(448.8878f, 0.0177803f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(448.3713f, 0.0177803f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.2697f, 110.9676f), new Vector2(-227.3552f, 1624.108f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(106.1483f, 83.81799f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 0f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(108.9976f, 135.1916f), new Vector2(14.00008f, 262.1069f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.1332f, 138.5247f), new Vector2(-121.0987f, 11.20007f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(109.0334f, 137.7266f), new Vector2(-88.39916f, 6.700062f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(288.2238f, 109.9452f), new Vector2(-227.3552f, 1624.108f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(285.2856f, 83.18229f), new Vector2(20.30011f, 329.411f), Quaternion.Euler(0f, 0f, 0f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(291.1626f, 82.43203f), new Vector2(20.30011f, 329.411f), Quaternion.Euler(0f, 0f, 0f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(288.0839f, 134.9934f), new Vector2(13.90008f, 138.2993f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(288.1266f, 136.6092f), new Vector2(95.49918f, 13.80008f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(288.0835f, 135.8569f), new Vector2(42f, 18.0001f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(45.88883f, 61.13737f), new Vector2(70.19957f, 898.5277f), Quaternion.Euler(0f, 0f, 345f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(50.15319f, 75.84881f), new Vector2(9.000065f, 235.6053f), Quaternion.Euler(0f, 0f, 327.5f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(50.09013f, 74.18565f), new Vector2(9.100065f, 179.3018f), Quaternion.Euler(0f, 0f, 346f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(13.70602f, 1.100433f), new Vector2(-347.1119f, 54.29981f), Quaternion.Euler(0f, 0f, 331.3f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(20.74422f, 1.172993f), new Vector2(389.7147f, 52.19984f), Quaternion.Euler(0f, 0f, 354.9f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(42.92248f, 47.96706f), new Vector2(8.500063f, 71.89954f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(41.85674f, 48.03367f), new Vector2(10.40007f, 87.19931f), Quaternion.Euler(0f, 0f, 345f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(281.356f, 130.8683f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 297.2f), TilePreviewLoaded826692544, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(274.8f, 126.3f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 312.3f), TilePreviewLoaded408694784, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(268.9607f, 120.7657f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded946389504, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(263.1571f, 114.9621f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded318699808, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(258.4282f, 108.5853f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 330f), TilePreviewLoaded553624512, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(253.6993f, 102.2085f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded378527008, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(248.039f, 96.47654f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded391556512, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(242.2835f, 90.76134f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded774635008, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(237.4349f, 84.36777f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 330f), TilePreviewLoaded883706944, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(235.5004f, 80.92859f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 327.8f), TilePreviewLoaded301308640, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(197.4f, 74.4f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 73.99999f), TilePreviewLoaded244207792, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(196.9473f, 75.41521f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 90f), TilePreviewLoaded175684256, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(227.4938f, 68.59419f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 345f), TilePreviewLoaded692554304, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(228.0335f, 67.05228f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 1.001791E-05f), TilePreviewLoaded173006720, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(252.2947f, 82.74483f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 328f), TilePreviewLoaded666779392, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(256.5259f, 89.41442f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 328.9f), TilePreviewLoaded658064320, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(261.2592f, 95.51029f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded326574112, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(266.9965f, 101.1759f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded211799536, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(271.8731f, 107.3434f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 329.6f), TilePreviewLoaded110415456, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(275.961f, 114.0847f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 330f), TilePreviewLoaded443195136, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(279.9771f, 120.8261f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 330f), TilePreviewLoaded290618400, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(283.9214f, 127.4957f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 330f), TilePreviewLoaded214045376, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(268.4714f, 82.24996f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded138180320, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(273.3315f, 88.43559f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 329.1f), TilePreviewLoaded115235664, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(277.5f, 95.4f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 330f), TilePreviewLoaded355104768, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(282.3154f, 101.6169f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 315f), TilePreviewLoaded878486400, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(284.2896f, 113.6993f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 345f), TilePreviewLoaded130779400, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(389.6488f, 58.65593f), new Vector2(30.00014f, 289.8086f), Quaternion.Euler(0f, 0f, 7.600017f), TilePreviewLoaded634099968, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(388.0778f, 66.2455f), new Vector2(36.60008f, 289.8086f), Quaternion.Euler(0f, 0f, 15f), TilePreviewLoaded987983, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(386.2075f, 73.49315f), new Vector2(36.70008f, 289.8086f), Quaternion.Euler(0f, 0f, 15f), TilePreviewLoaded204733936, "Back", true, 0);
                CreateLightSources("Light", new Vector2(108.9791f, 139.2009f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255, 255, 255), 1f);
                CreateLightSources("Light", new Vector2(288.0759f, 137.2268f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255, 255, 255), 1f);
                CreateParticleSources("Particles", new Vector2(288.2887f, 133.2611f), 1f, "Spark");
                CreateParticleSources("Particles", new Vector2(109.3753f, 138.1025f), 1f, "Spark");
                CreateGameObjects("Other", new Vector2(103.2719f, 130.948f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 313.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(97.34624f, 125.4613f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 313.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(91.42063f, 119.8283f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 313.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(86.22657f, 113.5369f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 328.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(81.91038f, 106.6603f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 328.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(77.93422f, 99.99529f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 328.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(73.05853f, 93.93118f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 313.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(67.42554f, 88.51765f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 313.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(62.5241f, 82.51888f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 328.5f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(333.5399f, 82.78122f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 22.00002f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(330.0008f, 90.06772f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 28.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(325.2f, 96.60001f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 43.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(319.5f, 102.6f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 43.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(313.8918f, 108.4959f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 43.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(308.4536f, 114.2172f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 43.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(302.9367f, 119.9423f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 43.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(297.5238f, 125.5633f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 43.50003f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(291.4865f, 130.4557f), new Vector2(9.200066f, 289.8086f), Quaternion.Euler(0f, 0f, 59.80001f), "Back", true, 0);
                CreateGameObjects("Other", new Vector2(387.2911f, 72.58842f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(387.1248f, 73.66343f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", true, 0);
                CreateGameObjects("Other", new Vector2(386.9008f, 74.82449f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(386.6429f, 75.37258f), new Vector2(42f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreatePhysicsGameObjects("PhysicsObject", new Vector2(387.1174f, 73.65925f), new Vector2(0.09999993f, 0.09999993f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1Loaded722400000, "Front", false);
                
			}
		}
	}

	public class MapLoadingStuff : MonoBehaviour
    {
		public void Awake()
        {
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
        {
			MapSelectionMenuBehaviour ingamemapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
			yield return new WaitForSeconds(0f);
			Mod.CreateMap(ingamemapmenu, Mod.mapname, "Template", Mod.TemplateSprite);
			Mod.debounce = false;
		}
    }

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
            {
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
    {
		public string Particles1;
		public float Speed1;
		public void Awake()
        {
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
    }

	public class LavaBurn : MonoBehaviour
    {
		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.BurnProgress < 0.95f)
						{
							if (physicalBehaviour.Properties.Flammability > 0.1f)
                            {
								physicalBehaviour.BurnProgress += 0.01f;
								physicalBehaviour.Ignite();
								physicalBehaviour.burnIntensity = 2f;
							}
							physicalBehaviour.Temperature += 10f;
							if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>())
                            {
								physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(5f);
							}
						}
					}
				}
			}
		}
	}

	public class AcidBurn : MonoBehaviour
	{
		public float a = 1;
		public float b = 1;
		public Color ACIDCOLOR = new Color(1,1,1,1);

		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				if (physicalBehaviour.transform.root.gameObject.GetComponent<WaterBlockBehaviour>())
				{
					continue;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() != null && !physicalBehaviour.isDisintegrated)
						{
							float random = UnityEngine.Random.Range(1f, 10f);
							var limb = physicalBehaviour.gameObject.GetComponent<LimbBehaviour>();
							var skin = physicalBehaviour.gameObject.GetComponent<SkinMaterialHandler>();
							if (physicalBehaviour.gameObject.name == "Head" || physicalBehaviour.gameObject.name == "Foot" || physicalBehaviour.gameObject.name == "FootFront")
                            {
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.025f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.025f;
							}
                            else
                            {
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.005f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.005f;
							}
							limb.Wince(limb.SkinMaterialHandler.AcidProgress * 100f);
							if (limb.SkinMaterialHandler.AcidProgress > 0.75f)
							{
								limb.BreakBone();
								limb.Health = 0f;
							}
							physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(10f);
							if (limb.Person.OxygenLevel <= 0.7f && !physicalBehaviour.isDisintegrated && physicalBehaviour.gameObject.name != "Head")
							{
								if (limb.Health <= 0f)
								{
									if (skin.RottenProgress >= 0.7f)
									{
										if (skin.AcidProgress >= 0.9f)
										{
											if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
											else
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
										}
									}
								}
							}
						}
						else if (physicalBehaviour.Properties.Flammability > 0.1f && !physicalBehaviour.isDisintegrated)
                        {
							if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.0005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
							else
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.0005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
						}
					}
				}
			}
		}
	}

	public class WaterBlockBehaviour : MonoBehaviour
	{
		public bool IsEvaporated
		{
			get
			{
				if (this.Lava == false)
				{
					return PhysicalBehaviour.AmbientTemperature > 200f;
				}
				else
				{
					return false;
				}
			}
		}

		public bool IsFrozen
		{
			get
			{
				if (this.Lava == false)
				{
					return PhysicalBehaviour.AmbientTemperature < 0f;
				}
				else
				{
					return false;
				}
			}
		}

		private void Awake()
		{
			if (base.gameObject.activeInHierarchy)
			{
				WaterBlockBehaviour.Instance = this;
			}
		}

		private void Start()
		{
			this.SpriteRenderer = base.GetComponent<SpriteRenderer>();
			if (base.gameObject.activeInHierarchy)
			{
				this.waterSizzles = Resources.LoadAll<AudioClip>("Audio/water_sizzle");
				WaterBlockBehaviour.Instance = this;
			}
			UpdateTemperatureState();
		}

		public static bool IsPointUnderWater(Vector3 pos)
		{
			return !WaterBlockBehaviour.Instance.IsEvaporated && !WaterBlockBehaviour.Instance.IsFrozen && pos.y < WaterBlockBehaviour.Instance.GlobalTop && pos.y > WaterBlockBehaviour.Instance.GlobalBottom && pos.x < WaterBlockBehaviour.Instance.GlobalRight && pos.x > WaterBlockBehaviour.Instance.GlobalLeft;
		}

		public static float GetWaterLevelOr(float fallback = -3.40282347E+38f)
		{
			if (!WaterBlockBehaviour.Instance)
			{
				return fallback;
			}
			if (WaterBlockBehaviour.Instance.IsEvaporated || WaterBlockBehaviour.Instance.IsFrozen)
			{
				return fallback;
			}
			return WaterBlockBehaviour.Instance.GlobalTop;
		}

		private void OnTriggerEnter2D(Collider2D collision)
		{
			if (!this.IsEvaporated && !this.IsFrozen)
			{
				this.DoSplash(collision);
			}
		}

		private void OnTriggerExit2D(Collider2D collision)
		{
			if (!this.IsEvaporated && !this.IsFrozen)
			{
				this.DoSplash(collision);
			}
		}

		private void DoSplash(Collider2D collision)
		{
			if (!UserPreferenceManager.Current.FancyEffects)
			{
				return;
			}
			if (collision.isTrigger)
			{
				return;
			}
			PhysicalBehaviour physicalBehaviour;
			if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out physicalBehaviour))
			{
				return;
			}
			Rigidbody2D rigidbody = physicalBehaviour.rigidbody;
			GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(this.Splash, this.Trigger.bounds.ClosestPoint(collision.transform.position), Quaternion.identity);
			gameObject.SetActive(true);
			Vector2 velocity = rigidbody.velocity;
			velocity.y = -Mathf.Abs(velocity.y);
			gameObject.transform.up = Vector2.Reflect(velocity, Vector2.up);
			float num = Mathf.Min(collision.bounds.extents.x, 4f);
			float num2 = Mathf.Clamp(rigidbody.velocity.magnitude * 0.5f * rigidbody.mass, 0.2f, 25f);
			gameObject.GetComponent<AudioSource>().volume = num2 / 15f;
			foreach (ParticleSystem particleSystem in gameObject.GetComponentsInChildren<ParticleSystem>())
			{
				ParticleSystem.ShapeModule shape = particleSystem.shape;
				ParticleSystem.MainModule main = particleSystem.main;
				shape.radius = num;
				main.startSizeMultiplier = num * 2.5f * UnityEngine.Random.Range(1f, 1.4f);
				main.startSpeedMultiplier = num2;
			}
		}

		public void UpdateTemperatureState()
		{
			if (this.IsFrozen)
			{
				this.SetFrozen();
				return;
			}
			this.Ice.gameObject.SetActive(false);
			if (this.wasFrozen)
			{
				foreach (PhysicalBehaviour physicalBehaviour in this.frozenInIce)
				{
					if (!physicalBehaviour)
					{
						return;
					}
					FrozenInIceBehaviour obj;
					if (physicalBehaviour.TryGetComponent<FrozenInIceBehaviour>(out obj))
					{
						UnityEngine.Object.Destroy(obj);
						FreezeStackController.RequestUnfreeze(physicalBehaviour.rigidbody);
					}
				}
				this.wasFrozen = false;
			}
			this.frozenInIce.Clear();
			if (this.IsEvaporated)
			{
				this.SetEvaporated();
				return;
			}
			this.BoilingWaterSound.SetActive(PhysicalBehaviour.AmbientTemperature >= 100f);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = true;
				}
			}
			this.Trigger.enabled = true;
			this.Trigger.isTrigger = true;
			this.SpriteRenderer.enabled = true;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(true);
			}
		}

		private void SetEvaporated()
		{
			this.BoilingWaterSound.SetActive(false);
			foreach (var renderer in base.GetComponents<Renderer>())
            {
				if (renderer != this.SpriteRenderer)
                {
					renderer.enabled = false;
				}
            }
			this.Trigger.enabled = false;
			this.SpriteRenderer.enabled = false;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(false);
			}
		}

		private void SetFrozen()
		{
			this.BoilingWaterSound.SetActive(false);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = false;
				}
			}
			this.Ice.gameObject.SetActive(true);
			this.wasFrozen = true;
			this.Trigger.isTrigger = false;
			this.SpriteRenderer.enabled = true;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(false);
			}
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!this.frozenInIce.Contains(physicalBehaviour))
				{
					int num = 0;
					int num2 = physicalBehaviour.LocalColliderGridPoints.Length;
					foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
					{
						if (physicalBehaviour.transform.TransformPoint(v).y <= this.GlobalTop && physicalBehaviour.transform.TransformPoint(v).y >= this.GlobalBottom && physicalBehaviour.transform.TransformPoint(v).x >= this.GlobalLeft && physicalBehaviour.transform.TransformPoint(v).y <= this.GlobalRight)
						{
							num++;
							if ((float)num / (float)num2 >= 0.1f)
							{
								physicalBehaviour.rigidbody.velocity = default(Vector2);
								physicalBehaviour.rigidbody.angularVelocity = 0f;
								FreezeStackController.RequestFreeze(physicalBehaviour.rigidbody);
								this.frozenInIce.Add(physicalBehaviour);
								physicalBehaviour.gameObject.AddComponent<FrozenInIceBehaviour>();
								physicalBehaviour.Temperature = Mathf.Min(physicalBehaviour.Temperature, PhysicalBehaviour.AmbientTemperature);
								break;
							}
						}
					}
				}
			}
		}

		private void FixedUpdate()
		{
			if (this.IsFrozen)
			{
				this.Ice.Temperature = PhysicalBehaviour.AmbientTemperature;
				foreach (PhysicalBehaviour physicalBehaviour in this.frozenInIce)
				{
					if (!physicalBehaviour)
					{
						return;
					}
					if (physicalBehaviour.OnFire)
					{
						physicalBehaviour.Extinguish();
					}
					FrozenInIceBehaviour obj;
					if (physicalBehaviour.transform.position.y > this.GlobalTop && physicalBehaviour.transform.position.y < this.GlobalBottom && physicalBehaviour.transform.position.y < this.GlobalRight && physicalBehaviour.transform.position.y > this.GlobalLeft && physicalBehaviour.TryGetComponent<FrozenInIceBehaviour>(out obj))
					{
						UnityEngine.Object.Destroy(obj);
						FreezeStackController.RequestUnfreeze(physicalBehaviour.rigidbody);
					}
				}
				return;
			}
			if (this.IsEvaporated)
			{
				return;
			}
			Vector3 a = Vector3.up * this.Buoyancy;
			float num = Mathf.Min(PhysicalBehaviour.AmbientTemperature, 100f);
			bool flag = PhysicalBehaviour.AmbientTemperature >= 100f;
			foreach (PhysicalBehaviour physicalBehaviour2 in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour2)
				{
					break;
				}
				float num2 = Mathf.Clamp(Mathf.Pow(Mathf.Abs(physicalBehaviour2.transform.position.y - this.GlobalTop), 0.25f), 1f, 8f);
				float d = Mathf.Clamp01((num2 - 1f) / 7f) + 1f;
				Vector2 force = a * physicalBehaviour2.Properties.Buoyancy * physicalBehaviour2.rigidbody.mass / (float)physicalBehaviour2.LocalGridPointLength * num2;
				bool flag2 = false;
				physicalBehaviour2.CurrentWaterSurfaceLevel = this.GlobalTop;
				foreach (Vector2 v in physicalBehaviour2.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour2.transform.TransformPoint(v);
					if (vector.y <= this.GlobalTop && vector.y >= this.GlobalBottom && vector.x <= this.GlobalRight && vector.x >= this.GlobalLeft)
					{
						flag2 = true;
						physicalBehaviour2.rigidbody.AddForceAtPosition(force, vector);
						Vector2 pointVelocity = physicalBehaviour2.rigidbody.GetPointVelocity(vector);
						physicalBehaviour2.rigidbody.AddForceAtPosition(-pointVelocity * d * this.GetDragFactor(pointVelocity) * physicalBehaviour2.rigidbody.mass * 0.4f, vector);
					}
				}
				bool flag3 = !physicalBehaviour2.IsUnderWater;
				physicalBehaviour2.IsUnderWater = flag2;
				if (flag2)
				{
					AliveBehaviour aliveBehaviour;
					if (flag && AliveBehaviour.AliveByTransform.TryGetValue(physicalBehaviour2.transform.root, out aliveBehaviour))
					{
						physicalBehaviour2.BurnProgress = Mathf.Max(physicalBehaviour2.BurnProgress, 0.5f);
						aliveBehaviour.SendMessage("AddPain", 15f, SendMessageOptions.DontRequireReceiver);
					}
					physicalBehaviour2.Temperature = Mathf.Lerp(physicalBehaviour2.Temperature, num, 0.05f * physicalBehaviour2.Properties.HeatTransferSpeedMultiplier);
					if (flag3 && physicalBehaviour2.Temperature >= 100f && physicalBehaviour2.Temperature > num * 2f)
					{
						physicalBehaviour2.PlayClipOnce(this.waterSizzles.PickRandom<AudioClip>(), 1f);
						physicalBehaviour2.Sizzle(false);
					}
					physicalBehaviour2.Wetness += 0.1f;
					physicalBehaviour2.SendMessage("WaterImpact", physicalBehaviour2.rigidbody.velocity.magnitude, SendMessageOptions.DontRequireReceiver);
					physicalBehaviour2.SendMessage("Suspended", SendMessageOptions.DontRequireReceiver);
				}
			}
		}

		private void Update()
        {
			UpdateTemperatureState();
		}

		private float GetDragFactor(Vector2 velocity)
		{
			float num = velocity.sqrMagnitude * 0.1f;
			return Mathf.Clamp(Mathf.Pow(num + 1f, num * this.Drag), 0.2f, 1f);
		}

		private void OnWillRenderObject()
		{
			if (!this.mat)
			{
				this.mat = this.SpriteRenderer.material;
			}
			if (this.mat)
			{
				this.mat.SetFloat("_Temperature", PhysicalBehaviour.AmbientTemperature);
			}
		}

		public float Drag;
		public float Buoyancy;
		public float GlobalTop;
		public float GlobalBottom;
		public float GlobalLeft;
		public float GlobalRight;
		public Vector2 WaterCenter;
		public Vector2 WaterSize;
		public bool Lava = false;
		public GameObject[] ObjectsToBeActiveIfWater;
		public GameObject Splash;
		public GameObject BoilingWaterSound;
		public SpriteRenderer SpriteRenderer;
		public Collider2D Trigger;
		public Collider2D[] insideWater = new Collider2D[1024];
		public LayerMask Layers;
		public PhysicalBehaviour Ice;
		private bool wasFrozen;
		private AudioClip[] waterSizzles;
		private HashSet<PhysicalBehaviour> frozenInIce = new HashSet<PhysicalBehaviour>();
		private Material mat;
		public static WaterBlockBehaviour Instance;
	}
}

